#!/usr/bin/perl
+use v5.12;
+
use strict;
use warnings;
use Math::Trig qw(deg2rad pip2 great_circle_distance);
use JSON::XS;
use LWP::UserAgent;
-use XML::TreeBuilder;
-use YAML;
+use YAML::XS qw(LoadFile DumpFile);
-my $source = shift @ARGV;
+my $originfile = shift @ARGV;
+my $clusterfile = shift @ARGV;
my $zone = shift @ARGV;
-my $clusters = YAML::LoadFile("src/${source}");
+my $targetoriginfile = shift @ARGV;
+my $origins = LoadFile($originfile);
+my $clusters = LoadFile($clusterfile);
+my $gdnsname = shift @ARGV;
my @servers;
# Initialise cluster details
{
my $server = {
cluster => $cluster,
- pingdom => $cluster->{pingdom},
+ statuscake => $cluster->{statuscake},
bandwidth => $cluster->{bandwidth},
ipv4 => $cluster->{ipv4},
ipv6 => $cluster->{ipv6}
}
$cluster->{name} = $name;
-
- if ($ENV{PINGDOM_USERNAME} && $ENV{PINGDOM_PASSWORD})
- {
- $cluster->{status} = "down";
- }
- else
- {
- $cluster->{status} = "up";
- }
+ $cluster->{status} = "down";
}
# Initialise server details
foreach my $server (@servers)
{
- if ($ENV{PINGDOM_USERNAME} && $ENV{PINGDOM_PASSWORD})
+ $server->{status} = "up";
+}
+
+# If statuscake support is enabled then check which servers are up
+if ($ENV{STATUSCAKE_USERNAME} && $ENV{STATUSCAKE_APIKEY})
+{
+ my $ua = LWP::UserAgent->new;
+ my $cache;
+
+ $ua->agent("mkgeo/1.0");
+ $ua->default_header("Username", $ENV{STATUSCAKE_USERNAME});
+ $ua->default_header("API", $ENV{STATUSCAKE_APIKEY});
+
+ if (-f "statuscake.yml")
{
- $server->{status} = "down";
+ $cache = LoadFile("statuscake.yml");
}
else
{
- $server->{status} = "up";
+ $cache = {};
}
-}
-# If pingdom support is enabled then check which servers are up
-if ($ENV{PINGDOM_USERNAME} && $ENV{PINGDOM_PASSWORD})
-{
- my $ua = LWP::UserAgent->new;
+ my $response = $ua->get("https://app.statuscake.com/API/Tests/");
- $ua->default_header("App-Key", "2cohi62u5haxvqmypk3ljqqrze1jufrh");
- $ua->credentials("api.pingdom.com:443", "Pingdom API", $ENV{PINGDOM_USERNAME}, $ENV{PINGDOM_PASSWORD});
+ if ($response->is_success)
+ {
+ my $tests = decode_json($response->content);
+
+ foreach my $test (@$tests)
+ {
+ my $testid = $test->{TestID};
+
+ if ($test->{Status} eq "Up" && !$test->{Paused})
+ {
+ $cache->{$testid} = "up";
+ }
+ else
+ {
+ $cache->{$testid} = "down";
+ }
+ }
+ }
foreach my $server (@servers)
{
- if (my $checkid = $server->{pingdom})
+ if (my $testids = $server->{statuscake})
{
- my $response = $ua->get("https://api.pingdom.com/api/2.0/checks/${checkid}");
+ $server->{status} = "up";
- if ($response->is_success)
+ for my $testid (@$testids)
{
- my $check = decode_json($response->content);
-
- $server->{status} = $check->{check}->{status};
+ my $testresult = $cache->{$testid} || "down";
- if ($server->{status} eq "up")
- {
- $server->{cluster}->{status} = "up";
- }
- else
- {
- $server->{cluster}->{bandwidth} = $server->{cluster}->{bandwidth} - $server->{bandwidth};
- }
+ $server->{status} = "down" if $testresult eq "down";
}
}
+ else
+ {
+ $server->{status} = "down";
+ }
+ }
+
+ DumpFile("statuscake.yml", $cache);
+}
+
+# Mark a cluster as up if any servers are up
+foreach my $server (@servers)
+{
+ if ($server->{status} eq "up")
+ {
+ $server->{cluster}->{status} = "up";
+ }
+ else
+ {
+ $server->{cluster}->{bandwidth} = $server->{cluster}->{bandwidth} - $server->{bandwidth};
}
}
+# Create target origins object
+my $targetorigins = {};
+
# Initialise cluster details
while (my($name,$cluster) = each %$clusters)
{
$cluster->{bandwidth_limit} = $cluster->{bandwidth} * 1024 * 1024;
$cluster->{bandwidth_used} = 0;
+
+ $targetorigins->{$cluster->{name}} = {
+ code => $cluster->{name},
+ name => $cluster->{name},
+ lat => $cluster->{lat},
+ lon => $cluster->{lon},
+ bandwidth => 0
+ };
}
-my %countries = ();
my @mappings = ();
-# Create a parser for the country database
-my $countries = XML::TreeBuilder->new;
-
-# Parse the country database
-$countries->parsefile("lib/countries.xml");
-
-# Load the per-country bandwidth details
-my $bandwidth = YAML::LoadFile("bandwidth/${source}.yml");
-
-# Fill in country table and work out which clusters each can use
-foreach my $country ($countries->look_down("_tag" => "country"))
+# Scan origins and work out which clusters each can use
+foreach my $origin (values %$origins)
{
- my $code = $country->look_down("_tag" => "countryCode")->as_text;
- my $name = $country->look_down("_tag" => "countryName")->as_text;
- my $population = $country->look_down("_tag" => "population")->as_text;
- my $bandwidth = $bandwidth->{$code} || 0;
- my $continent = $country->look_down("_tag" => "continent")->as_text;
- my $west = $country->look_down("_tag" => "west")->as_text;
- my $north = $country->look_down("_tag" => "north")->as_text;
- my $east = $country->look_down("_tag" => "east")->as_text;
- my $south = $country->look_down("_tag" => "south")->as_text;
- my $lat = centre_lat( $south, $north );
- my $lon = centre_lon( $west, $east );
-
- $countries{$code} = {
- code => $code, name => $name, continent => $continent,
- bandwidth => $bandwidth, lat => $lat, lon => $lon
- };
-
foreach my $cluster (values %$clusters)
{
- my $match = match_country($cluster, $code, $continent);
+ my $match = match_origin($cluster, $origin);
if ($cluster->{status} eq "up" && $match ne "denied")
{
my $priority = $match eq "preferred" ? 20 : 10;
- my $distance = distance($lat, $lon, $cluster->{lat}, $cluster->{lon});
+ my $distance = distance($origin->{lat}, $origin->{lon}, $cluster->{lat}, $cluster->{lon});
push @mappings, {
- country => $countries{$code}, cluster => $cluster,
+ origin => $origin, cluster => $cluster,
priority => $priority, distance => $distance
};
}
}
}
-# Discard the parsed country database
-$countries->delete;
-
# Allocate each country to a cluster
-allocate_clusters(\@mappings);
+allocate_clusters(@mappings);
-# If we failed to allocate every country then loop, increasing
+# If we failed to allocate every origin then loop, increasing
# the bandwidth for each cluster by a little and retrying until
# we manage to allocate everything
-while (grep { !exists($_->{cluster}) } values %countries)
+while (grep { !exists($_->{cluster}) } values %$origins)
{
# Clear any existing mappings of countries to clusters
- foreach my $country (values %countries)
+ foreach my $origin (values %$origins)
{
- delete $country->{cluster};
+ delete $origin->{cluster};
}
# Reset bandwidth usage for clusters and increase limits by 10%
}
# Try the allocate again
- allocate_clusters(\@mappings);
+ allocate_clusters(@mappings);
}
# Create JSON collection object
my @json;
# Open output files
-my $zonefile = IO::File->new("> data/${zone}") || die "$!";
-my $jsonfile = IO::File->new("> json/${zone}.json") || die "$!";
+my $zonefile = IO::File->new("> include/${zone}.js") || die "$!";
+my $jsonfile = IO::File->new("> json/${zone}.openstreetmap.org.json") || die "$!";
+
+# Output headers
+$zonefile->print("var \U${zone}\E_RECORDS = [\n");
# Output details for each country
-foreach my $country (values %countries)
+foreach my $origin (sort { $a->{name} cmp $b->{name} } values %$origins)
{
- my $cluster = $country->{cluster};
- my $clon = $country->{lon};
- my $clat = $country->{lat};
+ my $cluster = $origin->{cluster};
+ my $clon = $origin->{lon};
+ my $clat = $origin->{lat};
my $slon = $cluster->{lon};
my $slat = $cluster->{lat};
$clon = $clon + 360;
}
- $zonefile->print("# $country->{name}\n");
- $zonefile->print("C\L$country->{code}\E.${zone}:$cluster->{name}.${zone}:600\n");
+ if (!defined($gdnsname))
+ {
+ $zonefile->print(" CNAME(\"\L$origin->{code}\E.${zone}\", \"$cluster->{name}.${zone}.openstreetmap.org.\", TTL(\"10m\")),\n");
+ }
push @json, {
type => "Feature",
coordinates => [ [ $clon, $clat ], [ $slon, $slat ] ]
},
properties => {
- country => $country->{name},
+ origin => $origin->{name},
server => $cluster->{name},
colour => $cluster->{colour}
}
};
+
+ $targetorigins->{$cluster->{name}}->{bandwidth} += $origin->{bandwidth};
}
-# Output default records for IPs that can't be mapped to a country
-foreach my $cluster (grep { $clusters->{$_}->{default} } keys %$clusters)
+# Skip default records if we don't need them
+if (!defined($gdnsname))
{
- $zonefile->print("# Unknown countries\n");
- $zonefile->print("Cxx.${zone}:${cluster}.${zone}:600\n");
-}
+ # Output default records for IPs that can't be mapped to a country
+ foreach my $cluster (sort { $a->{name} cmp $b->{name} } values %$clusters)
+ {
+ my $name = $cluster->{name};
-$zonefile->print("# Servers\n");
+ if (my $default = $cluster->{default})
+ {
+ output_server($zonefile, "${default}.${zone}", $cluster, 0);
+ }
+ elsif (exists($cluster->{default}))
+ {
+ output_server($zonefile, "${zone}", $cluster, 0);
+ }
+ }
+}
# Output A records for each cluster
-while (my($name,$cluster) = each %$clusters)
+foreach my $cluster (sort { $a->{name} cmp $b->{name} } values %$clusters)
{
- foreach my $server (@{$cluster->{servers}})
- {
- if ($server->{status} eq "up")
- {
- $zonefile->print("+${name}.${zone}:$server->{ipv4}:600\n");
+ my $name = $cluster->{name};
- if ($server->{ipv6})
- {
-# $zonefile->print("3${name}.${zone}:$server->{ipv6}:600\n");
- }
- }
+ if (@{$cluster->{servers}} > 1)
+ {
+ output_server($zonefile, "${name}-%02d.${zone}", $cluster, 1);
+ }
+ else
+ {
+ output_server($zonefile, "${name}.${zone}", $cluster, 1);
}
}
# Output the GeoJSON text
$jsonfile->print(encode_json(\@json));
+# Output footers
+$zonefile->print("];\n");
+
# Close the output files
-$jsonfile->close();
+$zonefile->close();
$zonefile->close();
-exit 0;
-
-#
-# Find the centre value between two latitudes
-#
-sub centre_lat
+# Output gdnsd configuration
+if (defined($gdnsname))
{
- my $south = shift;
- my $north = shift;
+ my $gdnsmapfile = IO::File->new("> gdns/${gdnsname}.map") || die "$!";
+ my $gdnsresourcefile = IO::File->new("> gdns/${gdnsname}.resource") || die "$!";
+ my $gdnsweightedfile = IO::File->new("> gdns/${gdnsname}.weighted") || die "$!";
+ my $continent = "";
+
+ $gdnsmapfile->print("${gdnsname} => {\n");
+ $gdnsmapfile->print(" geoip2_db => /usr/share/GeoIP/GeoLite2-Country.mmdb\n");
+ $gdnsmapfile->print(" datacenters => [" . join(",", sort(keys(%$clusters))) . "]\n");
+ $gdnsmapfile->print(" map => {\n");
+ $gdnsmapfile->print(" default => [" . join(",", sort(map { $_->{name} } grep { $_->{default} } values(%$clusters))) . "]\n");
+
+ foreach my $origin (sort { $a->{continent} cmp $b->{continent} || $a->{code} cmp $b->{code} } values %$origins)
+ {
+ my $code = $origin->{code};
+ my $cluster = $origin->{cluster}->{name};
- return ( $south + $north ) / 2;
-}
+ next if $code eq "XK";
-#
-# Find the centre value between two longitudes
-#
-sub centre_lon
-{
- my $west = shift;
- my $east = shift;
- my $lon;
+ if ($continent ne $origin->{continent})
+ {
+ $gdnsmapfile->print(" }\n") if $continent;
- if ($west < $east)
- {
- $lon = ( $west + $east ) / 2;
+ $continent = $origin->{continent};
+
+ $gdnsmapfile->print(" ${continent} => {\n");
+ }
+
+ $gdnsmapfile->print(" ${code} => [${cluster}]\n");
}
- else
+
+ $gdnsmapfile->print(" }\n") if $continent;
+
+ $gdnsmapfile->print(" }\n");
+ $gdnsmapfile->print("}\n");
+
+ $gdnsresourcefile->print("${gdnsname} => {\n");
+ $gdnsresourcefile->print(" map => ${gdnsname}\n");
+ $gdnsresourcefile->print(" dcmap => {\n");
+
+ foreach my $cluster (sort { $a->{name} cmp $b->{name} } values %$clusters)
{
- $lon = ( $west + $east + 360 ) / 2;
+ my $name = $cluster->{name};
+
+ if (@{$cluster->{servers}} > 1 && grep { $_->{status} eq "up" } @{$cluster->{servers}})
+ {
+ $gdnsweightedfile->print("${name} => {\n");
+
+ while (my($index,$server) = each @{$cluster->{servers}})
+ {
+ if ($server->{status} eq "up")
+ {
+ my $number = sprintf("%02d", $index + 1);
+ my $bandwidth = $server->{bandwidth};
+
+ $gdnsweightedfile->print(" ${name}-${number} = [ ${name}-${number}.${zone}.openstreetmap.org., ${bandwidth} ]\n");
+ }
+ }
+
+ $gdnsweightedfile->print("}\n");
+
+ $gdnsresourcefile->print(" ${name} => %weighted!${name}\n");
+ }
+ else
+ {
+ $gdnsresourcefile->print(" ${name} => ${name}.${zone}.openstreetmap.org.\n");
+ }
}
- $lon = $lon - 360 if $lon > 180;
+ $gdnsresourcefile->print(" }\n");
+ $gdnsresourcefile->print("}\n");
- return $lon
+ $gdnsweightedfile->close();
+ $gdnsresourcefile->close();
+ $gdnsmapfile->close();
}
+# Output the target details in origin format if required
+DumpFile($targetoriginfile, $targetorigins) if $targetoriginfile;
+
+exit 0;
+
#
-# Match a country against a cluster
+# Match an origin against a cluster
#
-sub match_country
+sub match_origin
{
my $cluster = shift;
- my $country = shift;
- my $continent = shift;
+ my $origin = shift;
my $match;
if ($cluster->{preferred} &&
- $cluster->{preferred}->{countries} &&
- grep { $_ eq $country } @{$cluster->{preferred}->{countries}})
+ $cluster->{preferred}->{origins} &&
+ grep { $_ eq $origin->{name} } @{$cluster->{preferred}->{origins}})
{
$match = "preferred";
}
+ elsif ($cluster->{allowed} &&
+ $cluster->{allowed}->{origins} &&
+ grep { $_ eq $origin->{name} } @{$cluster->{allowed}->{origins}})
+ {
+ $match = "allowed";
+ }
elsif ($cluster->{preferred} &&
- $cluster->{preferred}->{continents} &&
- grep { $_ eq $continent } @{$cluster->{preferred}->{continents}})
+ $cluster->{preferred}->{countries} &&
+ grep { $_ eq $origin->{country} } @{$cluster->{preferred}->{countries}})
{
$match = "preferred";
}
elsif ($cluster->{allowed} &&
$cluster->{allowed}->{countries} &&
- grep { $_ eq $country } @{$cluster->{allowed}->{countries}})
- {
- $match = "allowed";
- }
- elsif ($cluster->{allowed} &&
- $cluster->{allowed}->{continents} &&
- grep { $_ eq $continent } @{$cluster->{allowed}->{continents}})
+ grep { $_ eq $origin->{country} } @{$cluster->{allowed}->{countries}})
{
$match = "allowed";
}
elsif ($cluster->{denied} &&
$cluster->{denied}->{countries} &&
- grep { $_ eq $country } @{$cluster->{preferred}->{countries}})
+ grep { $_ eq $origin->{country} } @{$cluster->{denied}->{countries}})
{
$match = "denied";
}
+ elsif ($cluster->{preferred} &&
+ $cluster->{preferred}->{continents} &&
+ grep { $_ eq $origin->{continent} } @{$cluster->{preferred}->{continents}})
+ {
+ $match = "preferred";
+ }
+ elsif ($cluster->{allowed} &&
+ $cluster->{allowed}->{continents} &&
+ grep { $_ eq $origin->{continent} } @{$cluster->{allowed}->{continents}})
+ {
+ $match = "allowed";
+ }
elsif ($cluster->{denied} &&
$cluster->{denied}->{continents} &&
- grep { $_ eq $continent } @{$cluster->{preferred}->{continents}})
+ grep { $_ eq $origin->{continent} } @{$cluster->{denied}->{continents}})
{
$match = "denied";
}
}
#
-# Allocate each country to a cluster
+# Allocate each origin to a cluster
#
sub allocate_clusters
{
- my $mappings = shift;
+ my @mappings = sort { compare_mappings($a, $b) } @_;
- # Loop over the mappings, trying to assign each country to the
+ # Loop over the mappings, trying to assign each origin to the
# nearest cluster, but subject to the bandwidth limits
- foreach my $mapping (sort { $b->{priority} <=> $a->{priority} || $a->{distance} <=> $b->{distance} } @$mappings)
+ while (my $mapping = shift @mappings)
{
- my $country = $mapping->{country};
- my $cluster = $mapping->{cluster};
+ my @group;
+
+ push @group, $mapping;
+
+ while (@mappings && compare_mappings($mapping, $mappings[0]) == 0)
+ {
+ push @group, shift @mappings;
+ }
+
+ for my $mapping (sort compare_bandwidth @group)
+ {
+ my $origin = $mapping->{origin};
+ my $cluster = $mapping->{cluster};
+
+ if (!exists($origin->{cluster}) &&
+ $cluster->{bandwidth_used} + $origin->{bandwidth} <= $cluster->{bandwidth_limit})
+ {
+ $origin->{cluster} = $cluster;
+ $cluster->{bandwidth_used} = $cluster->{bandwidth_used} + $origin->{bandwidth};
+ }
+ }
+ }
+
+ return;
+}
+
+#
+# Compare two mappings to decide which to use
+#
+sub compare_mappings
+{
+ my $a = shift;
+ my $b = shift;
+
+ return $b->{priority} <=> $a->{priority} ||
+ $a->{distance} <=> $b->{distance};
+}
+
+#
+# Compare two mappings to decide which to try first
+#
+sub compare_bandwidth
+{
+ my $a_used = ( $a->{cluster}->{bandwidth_used} * 100.0 ) / ( $a->{cluster}->{bandwidth_limit} * 1.0 );
+ my $b_used = ( $b->{cluster}->{bandwidth_used} * 100.0 ) / ( $b->{cluster}->{bandwidth_limit} * 1.0 );
+
+ return $a_used <=> $b_used;
+}
- if (!exists($country->{cluster}) &&
- $cluster->{bandwidth_used} + $country->{bandwidth} <= $cluster->{bandwidth_limit})
+#
+# Output DNS records for a server
+#
+sub output_server
+{
+ my $zonefile = shift;
+ my $name = shift;
+ my $cluster = shift;
+ my $all = shift;
+
+ while (my($index,$server) = each @{$cluster->{servers}})
+ {
+ if ($all || $server->{status} eq "up")
{
- $country->{cluster} = $cluster;
- $cluster->{bandwidth_used} = $cluster->{bandwidth_used} + $country->{bandwidth};
+ $zonefile->printf(" A(\"${name}\", \"$server->{ipv4}\", TTL(\"10m\")),\n", $index + 1);
+
+ if ($server->{ipv6})
+ {
+ $zonefile->printf(" AAAA(\"${name}\", \"$server->{ipv6}\", TTL(\"10m\")),\n", $index + 1);
+ }
}
}